// DlgPtnEdge.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "FPM.h"
#include "DlgPtnEdge.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#define SAFE_RELEASE(p)      { if(p) { (p)->Release(); (p)=NULL; } }

/////////////////////////////////////////////////////////////////////////////
// CDlgPtnEdge _CAO


CDlgPtnEdge::CDlgPtnEdge(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgPtnEdge::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgPtnEdge)
	//}}AFX_DATA_INIT

	m_Fpm = NULL;
	m_Ptn = NULL;
}


void CDlgPtnEdge::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgPtnEdge)
	DDX_Control(pDX, IDC_CHECK_EDGE_DISP, m_chkEdgeDisp);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgPtnEdge, CDialog)
	//{{AFX_MSG_MAP(CDlgPtnEdge)
	ON_WM_SIZE()
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_CHECK_EDGE_DISP, OnCheckEdgeDisp)
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgPtnEdge bZ[W nh


BOOL CDlgPtnEdge::OnInitDialog() 
{
	CDialog::OnInitDialog();

	CoInitialize( NULL ); 
	CWnd *pwnd; 
	IUnknown *p_unknown;
	
	pwnd = GetDlgItem( IDC_FVXDISPLAYEX1 );
	p_unknown = pwnd->GetControlUnknown();
	p_unknown->QueryInterface( __uuidof(IFvxDisplayExPtr), (void**)&m_FvxDisplayEx ); 


    m_chkEdgeDisp.SetCheck(1);

	m_FvxDisplayEx->CreateDisplay(16,0);
	m_FvxDisplayEx->DrawImage(m_Ptn);

	
	m_Edges.CreateInstance( __uuidof( FvPointGroup) ); 
	m_Fpm->GetEdgeData(m_Ptn,m_Edges);
	
	m_FvxDisplayEx->PutPenWidth(1);
	m_FvxDisplayEx->PenColor = RGB(255, 0, 255);
	m_FvxDisplayEx->DrawData(0,m_Edges);


	CScrollBar *m_hscroll = (CScrollBar*)GetDlgItem(IDC_SCROLLBAR1);

	// XN[͈͂ݒ
	m_hscroll->SetScrollRange(1, 7);


	if( 0 == m_nSelectFilter )
		(GetDlgItem(IDC_FILTER))->SetWindowText(_T("փGbWtB^"));
	else
		(GetDlgItem(IDC_FILTER))->SetWindowText(_T("\[xtB^"));


	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CDlgPtnEdge::SetFPM(IUnknown* /*IFvxFPMPtr*/ pFPM)
{
	pFPM->QueryInterface(__uuidof(IFvxFPM), (void**)&m_Fpm);
}

void CDlgPtnEdge::SetPattern(IUnknown* /*IFvxPattern4Ptr*/ pPtn)
{
	pPtn->QueryInterface(__uuidof(IFvxPattern4), (void**)&m_Ptn);
}

void CDlgPtnEdge::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	if( NULL != m_FvxDisplayEx ) {
		::MoveWindow( (HWND)m_FvxDisplayEx->GetHWnd(), 8, 66, cx-8, cy-80, TRUE );

	}
	
}	


void CDlgPtnEdge::OnClose() 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	SAFE_RELEASE(m_Fpm);
	SAFE_RELEASE(m_Ptn);

	CDialog::OnClose();
}

void CDlgPtnEdge::SetSelectFilter(int nIndex)
{
	m_nSelectFilter = nIndex;
}

void CDlgPtnEdge::OnCheckEdgeDisp() 
{
	// GbW̕\\
	if( m_chkEdgeDisp.GetCheck() )
		m_FvxDisplayEx->SetOverlayEnable(0,VARIANT_TRUE);
	else
		m_FvxDisplayEx->SetOverlayEnable(0,VARIANT_FALSE);	
}

void CDlgPtnEdge::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
   int pos=pScrollBar->GetScrollPos();
   
   switch(nSBCode)
   {
	  case SB_LINELEFT:   // 
            pos = pos - 1;	break;
      case SB_LINERIGHT:  // E
            pos = pos + 1;	break;
	  case SB_PAGELEFT:   // ̈
            pos = pos - 10;	break;
      case SB_PAGERIGHT:  // Ë
            pos = pos + 10;	break;
	  case SB_THUMBPOSITION:	// XN[{bNXΈړꍇ
	
	  case SB_THUMBTRACK:
			pos = nPos;		break;	// XN[{bNXhbOړꍇ
	}

    pScrollBar->SetScrollPos(pos);
	pos=pScrollBar->GetScrollPos();

	CString str;
	m_FvxDisplayEx->Magnification = (pos - ((pos - 1) * 0.5));
	str.Format(_T("x%.2lf"), m_FvxDisplayEx->Magnification);

	(GetDlgItem(IDC_STATIC_DISP_SIZE))->SetWindowText(str);
	
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}
